------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt4.Sql_Fields;
with Qt4.Strings;
with Qt4.Variants;
private with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.Sql_Records is

   type Q_Sql_Record is tagged private;

   procedure Append
    (Self : in out Q_Sql_Record'Class;
     Field : Qt4.Sql_Fields.Q_Sql_Field'Class);

   procedure Clear
    (Self : in out Q_Sql_Record'Class);

   procedure Clear_Values
    (Self : in out Q_Sql_Record'Class);

   function Contains
    (Self : Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class)
       return Boolean;

   function Count
    (Self : Q_Sql_Record'Class)
       return Qt4.Q_Integer;

   function Field
    (Self : Q_Sql_Record'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Sql_Fields.Q_Sql_Field;

   function Field
    (Self : Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class)
       return Qt4.Sql_Fields.Q_Sql_Field;

   function Field_Name
    (Self : Q_Sql_Record'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Strings.Q_String;

   function Index_Of
    (Self : Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class)
       return Qt4.Q_Integer;

   procedure Insert
    (Self : in out Q_Sql_Record'Class;
     Pos : Qt4.Q_Integer;
     Field : Qt4.Sql_Fields.Q_Sql_Field'Class);

   function Is_Empty
    (Self : Q_Sql_Record'Class)
       return Boolean;

   function Is_Generated
    (Self : Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class)
       return Boolean;

   function Is_Generated
    (Self : Q_Sql_Record'Class;
     Index : Qt4.Q_Integer)
       return Boolean;

   function Is_Null
    (Self : Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class)
       return Boolean;

   function Is_Null
    (Self : Q_Sql_Record'Class;
     Index : Qt4.Q_Integer)
       return Boolean;

   procedure Remove
    (Self : in out Q_Sql_Record'Class;
     Pos : Qt4.Q_Integer);

   procedure Replace
    (Self : in out Q_Sql_Record'Class;
     Pos : Qt4.Q_Integer;
     Field : Qt4.Sql_Fields.Q_Sql_Field'Class);

   procedure Set_Generated
    (Self : in out Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class;
     Generated : Boolean);

   procedure Set_Generated
    (Self : in out Q_Sql_Record'Class;
     Index : Qt4.Q_Integer;
     Generated : Boolean);

   procedure Set_Null
    (Self : in out Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class);

   procedure Set_Null
    (Self : in out Q_Sql_Record'Class;
     Index : Qt4.Q_Integer);

   procedure Set_Value
    (Self : in out Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class;
     Value : Qt4.Variants.Q_Variant'Class);

   procedure Set_Value
    (Self : in out Q_Sql_Record'Class;
     Index : Qt4.Q_Integer;
     Value : Qt4.Variants.Q_Variant'Class);

   function Value
    (Self : Q_Sql_Record'Class;
     Name : Qt4.Strings.Q_String'Class)
       return Qt4.Variants.Q_Variant;

   function Value
    (Self : Q_Sql_Record'Class;
     Index : Qt4.Q_Integer)
       return Qt4.Variants.Q_Variant;

   overriding function "="
    (Self : Q_Sql_Record;
     Other : Q_Sql_Record)
       return Boolean;

   package Internals is

      type QSqlRecord is private;

      type QSqlRecord_Access is access all QSqlRecord;
      pragma Convention (C, QSqlRecord_Access);

      function QSqlRecord_View
       (Item : Q_Sql_Record'Class)
          return QSqlRecord_Access;
      pragma Inline (QSqlRecord_View);

      function To_Pointer
       (Address : System.Address)
          return QSqlRecord_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QSqlRecord_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QSqlRecord_Access)
          return Q_Sql_Record;

   private

      type QSqlRecord is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QSqlRecord_C_Size_Of);
      end record;
      pragma Convention (C, QSqlRecord);

   end Internals;

private

   type Q_Sql_Record is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QSqlRecord;
      Object  : Internals.QSqlRecord_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Sql_Record);

   overriding
   procedure Finalize (Self : in out Q_Sql_Record);

   overriding
   procedure Initialize (Self : in out Q_Sql_Record);

end Qt4.Sql_Records;
